module.exports = function (grunt) {
    // Project configuration.
    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),

        // Minify JavaScript files.
        uglify: {
            options: {
                banner: '/*! <%= pkg.name %> - <%= grunt.template.today("yyyy-mm-dd") %> */\n',
                mangle: false // Prevent renaming of function and variable names.
            },
            build: {
                files: {
                    'amd/build/live_join.min.js': ['amd/src/live_join.js'],
                }
            }
        },

        // RequireJS configuration for Moodle AMD modules
        requirejs: {
            compile: {
                options: {
                    baseUrl: 'amd/src',
                    paths: {
                        'jquery': 'empty:',  // Tell RequireJS to exclude jQuery (it will be loaded by Moodle)
                        'core/ajax': 'empty:',
                        'core/notification': 'empty:'
                    },
                    name: 'block_zoomonline/live_join',  
                    out: 'amd/build/live_join.min.js',
                    optimize: 'uglify2'
                }
            }
        },

        // Watch for changes in files and re-run tasks.
        watch: {
            scripts: {
                files: ['amd/src/**/*.js'],
                tasks: ['uglify'],
                options: {
                    spawn: false,
                }
            }
        },

        // Clean build directories before generating new files.
        clean: {
            build: ['amd/build/*']
        }
    });

    // Load the plugins required for the tasks.
    grunt.loadNpmTasks('grunt-contrib-uglify');
    grunt.loadNpmTasks('grunt-contrib-watch');
    grunt.loadNpmTasks('grunt-contrib-clean');
    grunt.loadNpmTasks('grunt-contrib-requirejs');

    // Register tasks.
    grunt.registerTask('default', ['clean', 'uglify']);
    grunt.registerTask('amd', ['requirejs']);
};
